From cfb2c6c13f69be857deef647278cbbd0ea17c38e Mon Sep 17 00:00:00 2001
From: "Endi S. Dewata" <edewata@redhat.com>
Date: Mon, 28 Oct 2013 16:59:04 -0400
Subject: [PATCH] Updated version number to 10.0.6.

---
 scripts/compose_dogtag_pki_theme_packages |  2 +-
 scripts/compose_ipa_pki_theme_packages    |  2 +-
 scripts/compose_pki_console_packages      |  2 +-
 scripts/compose_pki_core_packages         |  2 +-
 scripts/compose_pki_migrate_packages      |  2 +-
 scripts/compose_pki_ra_packages           |  2 +-
 scripts/compose_pki_tps_packages          |  2 +-
 specs/dogtag-pki-theme.spec               |  5 +-
 specs/dogtag-pki.spec                     | 85 ++++++++++++++++---------------
 specs/ipa-pki-theme.spec                  |  5 +-
 specs/pki-console.spec                    |  5 +-
 specs/pki-core.spec                       |  7 ++-
 specs/pki-migrate.spec                    |  5 +-
 specs/pki-ra.spec                         |  5 +-
 specs/pki-tps.spec                        |  5 +-
 15 files changed, 81 insertions(+), 55 deletions(-)

diff --git a/scripts/compose_dogtag_pki_theme_packages b/scripts/compose_dogtag_pki_theme_packages
index c6083444d481e9f90cb00fe6f3e3f2a13228110f..644f2dbbbfd739bed86118da63d63554884a39c4 100755
--- a/scripts/compose_dogtag_pki_theme_packages
+++ b/scripts/compose_dogtag_pki_theme_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 DOGTAG_PKI_THEME="dogtag-pki-theme"
-DOGTAG_PKI_THEME_VERSION="10.0.5"
+DOGTAG_PKI_THEME_VERSION="10.0.6"
 
 
 ##
diff --git a/scripts/compose_ipa_pki_theme_packages b/scripts/compose_ipa_pki_theme_packages
index dd722a6dead4ba7d65c83d4a4d82ed01d98ec7c2..515c1b2e5b3ab537717bcbe4a556b548f93449d0 100755
--- a/scripts/compose_ipa_pki_theme_packages
+++ b/scripts/compose_ipa_pki_theme_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 IPA_PKI_THEME="ipa-pki-theme"
-IPA_PKI_THEME_VERSION="10.0.5"
+IPA_PKI_THEME_VERSION="10.0.6"
 
 
 ##
diff --git a/scripts/compose_pki_console_packages b/scripts/compose_pki_console_packages
index c9904fba803e8788b02e15be399e44a21afed548..f6aca935d59c01b74657389ff9ab6d16732f1f55 100755
--- a/scripts/compose_pki_console_packages
+++ b/scripts/compose_pki_console_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 PKI_CONSOLE="pki-console"
-PKI_CONSOLE_VERSION="10.0.5"
+PKI_CONSOLE_VERSION="10.0.6"
 
 
 ##
diff --git a/scripts/compose_pki_core_packages b/scripts/compose_pki_core_packages
index b5bdb46fc3065355f0661c60f5333e6b944f6586..3ff92feab98d0c604f3b31fd62b06143c33f4728 100755
--- a/scripts/compose_pki_core_packages
+++ b/scripts/compose_pki_core_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 PKI_CORE="pki-core"
-PKI_CORE_VERSION="10.0.5"
+PKI_CORE_VERSION="10.0.6"
 
 
 ##
diff --git a/scripts/compose_pki_migrate_packages b/scripts/compose_pki_migrate_packages
index 480549b6cd26c3e8db074f61f0114e5f4ad88781..6e7da3e9b5a99e6d7ac5775f63c1a90cc5fd343e 100755
--- a/scripts/compose_pki_migrate_packages
+++ b/scripts/compose_pki_migrate_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 PKI_MIGRATE="pki-migrate"
-PKI_MIGRATE_VERSION="10.0.5"
+PKI_MIGRATE_VERSION="10.0.6"
 
 
 ##
diff --git a/scripts/compose_pki_ra_packages b/scripts/compose_pki_ra_packages
index 8802b8729307a1080632e2cc0f203cd8273746a0..542aee276b111175a39009d6d78a2b6a615358b0 100755
--- a/scripts/compose_pki_ra_packages
+++ b/scripts/compose_pki_ra_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 PKI_RA="pki-ra"
-PKI_RA_VERSION="10.0.5"
+PKI_RA_VERSION="10.0.6"
 
 
 ##
diff --git a/scripts/compose_pki_tps_packages b/scripts/compose_pki_tps_packages
index 3b7e0076f65c863d2f5199226339f26a9abaddcb..63bcfb900e89f26b317a826afa3dbe6187be9cce 100755
--- a/scripts/compose_pki_tps_packages
+++ b/scripts/compose_pki_tps_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 PKI_TPS="pki-tps"
-PKI_TPS_VERSION="10.0.5"
+PKI_TPS_VERSION="10.0.6"
 
 
 ##
diff --git a/specs/dogtag-pki-theme.spec b/specs/dogtag-pki-theme.spec
index f809f091b92af501b662d67d6c87311947cf6b07..cf822c92752380b81532633634fb459f1edb106f 100644
--- a/specs/dogtag-pki-theme.spec
+++ b/specs/dogtag-pki-theme.spec
@@ -1,5 +1,5 @@
 Name:             dogtag-pki-theme
-Version:          10.0.5
+Version:          10.0.6
 Release:          1%{?dist}
 Summary:          Certificate System - Dogtag PKI Theme Components
 URL:              http://pki.fedoraproject.org/
@@ -217,6 +217,9 @@ cd build
 
 
 %changelog
+* Mon Oct 28 2013 Endi S. Dewata <edewata@redhat.com> 10.0.6-1
+- Updated version number.
+
 * Fri Sep 6 2013 Ade Lee <alee@redhat.com> 10.0.5-1
 - Roll release to next version
 
diff --git a/specs/dogtag-pki.spec b/specs/dogtag-pki.spec
index cf7361a312badabd6d0a400a4fd10edbdfa65261..085a353e6fe0e08b6b016bb0711f5e3a79fb6048 100644
--- a/specs/dogtag-pki.spec
+++ b/specs/dogtag-pki.spec
@@ -1,6 +1,6 @@
 Summary:          Dogtag Public Key Infrastructure (PKI) Suite
 Name:             dogtag-pki
-Version:          10.0.5
+Version:          10.0.6
 Release:          1%{?dist}
 # The entire source code is GPLv2 except for 'pki-tps' which is LGPLv2
 License:          GPLv2 and LGPLv2
@@ -11,67 +11,67 @@ BuildArch:        noarch
 
 # Establish MINIMUM package versions based upon platform
 %if 0%{?rhel} || 0%{?fedora} >= 19
-%define dogtag_pki_theme_version   10.0.5
+%define dogtag_pki_theme_version   10.0.6
 %define esc_version                1.1.0
 %define jss_version                4.2.6-28
-%define pki_core_version           10.0.5
-%define pki_kra_version            10.0.5
-%define pki_ocsp_version           10.0.5
-%define pki_ra_version             10.0.5
-%define pki_tks_version            10.0.5
-%define pki_tps_version            10.0.5
-%define pki_console_version        10.0.5
+%define pki_core_version           10.0.6
+%define pki_kra_version            10.0.6
+%define pki_ocsp_version           10.0.6
+%define pki_ra_version             10.0.6
+%define pki_tks_version            10.0.6
+%define pki_tps_version            10.0.6
+%define pki_console_version        10.0.6
 %define tomcatjss_version          7.1.0
 %else
 %if 0%{?fedora} >= 18
-%define dogtag_pki_theme_version   10.0.5
+%define dogtag_pki_theme_version   10.0.6
 %define esc_version                1.1.0
 %define jss_version                4.2.6-24
-%define pki_core_version           10.0.5
-%define pki_kra_version            10.0.5
-%define pki_ocsp_version           10.0.5
-%define pki_ra_version             10.0.5
-%define pki_tks_version            10.0.5
-%define pki_tps_version            10.0.5
-%define pki_console_version        10.0.5
+%define pki_core_version           10.0.6
+%define pki_kra_version            10.0.6
+%define pki_ocsp_version           10.0.6
+%define pki_ra_version             10.0.6
+%define pki_tks_version            10.0.6
+%define pki_tps_version            10.0.6
+%define pki_console_version        10.0.6
 %define tomcatjss_version          7.0.0-4
 %else
 %if 0%{?fedora} >= 17
-%define dogtag_pki_theme_version   10.0.5
+%define dogtag_pki_theme_version   10.0.6
 %define esc_version                1.1.0
 %define jss_version                4.2.6-24
-%define pki_core_version           10.0.5
-%define pki_kra_version            10.0.5
-%define pki_ocsp_version           10.0.5
-%define pki_ra_version             10.0.5
-%define pki_tks_version            10.0.5
-%define pki_tps_version            10.0.5
-%define pki_console_version        10.0.5
+%define pki_core_version           10.0.6
+%define pki_kra_version            10.0.6
+%define pki_ocsp_version           10.0.6
+%define pki_ra_version             10.0.6
+%define pki_tks_version            10.0.6
+%define pki_tps_version            10.0.6
+%define pki_console_version        10.0.6
 %define tomcatjss_version          7.0.0-3
 %else
 %if 0%{?fedora} >= 16
-%define dogtag_pki_theme_version   10.0.5
+%define dogtag_pki_theme_version   10.0.6
 %define esc_version                1.1.0
 %define jss_version                4.2.6-24
-%define pki_core_version           10.0.5
-%define pki_kra_version            10.0.5
-%define pki_ocsp_version           10.0.5
-%define pki_ra_version             10.0.5
-%define pki_tks_version            10.0.5
-%define pki_tps_version            10.0.5
-%define pki_console_version        10.0.5
+%define pki_core_version           10.0.6
+%define pki_kra_version            10.0.6
+%define pki_ocsp_version           10.0.6
+%define pki_ra_version             10.0.6
+%define pki_tks_version            10.0.6
+%define pki_tps_version            10.0.6
+%define pki_console_version        10.0.6
 %define tomcatjss_version          6.0.2
 %else
-%define dogtag_pki_theme_version   10.0.5
+%define dogtag_pki_theme_version   10.0.6
 %define esc_version                1.1.0
 %define jss_version                4.2.6-24
-%define pki_core_version           10.0.5
-%define pki_kra_version            10.0.5
-%define pki_ocsp_version           10.0.5
-%define pki_ra_version             10.0.5
-%define pki_tks_version            10.0.5
-%define pki_tps_version            10.0.5
-%define pki_console_version        10.0.5
+%define pki_core_version           10.0.6
+%define pki_kra_version            10.0.6
+%define pki_ocsp_version           10.0.6
+%define pki_ra_version             10.0.6
+%define pki_tks_version            10.0.6
+%define pki_tps_version            10.0.6
+%define pki_console_version        10.0.6
 %define tomcatjss_version          2.0.0
 %endif
 %endif
@@ -186,6 +186,9 @@ rm -rf %{buildroot}
 %doc README
 
 %changelog
+* Mon Oct 28 2013 Endi S. Dewata <edewata@redhat.com> 10.0.6-1
+- Updated version number.
+
 * Fri Sep 6 2013 Ade Lee <alee@redhat.com> 10.0.5-1
 - Roll release to next version
 
diff --git a/specs/ipa-pki-theme.spec b/specs/ipa-pki-theme.spec
index 370a79fdd2ad71b9e59052f9d660b99832e84c7f..6be24d11e0f8e954af8cec36b110e65ecce3c41e 100644
--- a/specs/ipa-pki-theme.spec
+++ b/specs/ipa-pki-theme.spec
@@ -1,5 +1,5 @@
 Name:             ipa-pki-theme
-Version:          10.0.5
+Version:          10.0.6
 Release:          1%{?dist}
 Summary:          Certificate System - IPA PKI Theme Components
 URL:              http://pki.fedoraproject.org/
@@ -115,6 +115,9 @@ cd build
 
 
 %changelog
+* Mon Oct 28 2013 Endi S. Dewata <edewata@redhat.com> 10.0.6-1
+- Updated version number.
+
 * Fri Sep 6 2013 Ade Lee <alee@redhat.com> 10.0.5-1
 - Roll release to next version
 
diff --git a/specs/pki-console.spec b/specs/pki-console.spec
index c31c1cf2c400c83bc481e8fda2d202b3792964df..e122f44a911f2d0d0534eb85abd074c646841555 100644
--- a/specs/pki-console.spec
+++ b/specs/pki-console.spec
@@ -1,5 +1,5 @@
 Name:             pki-console
-Version:          10.0.5
+Version:          10.0.6
 Release:          1%{?dist}
 Summary:          Certificate System - PKI Console
 URL:              http://pki.fedoraproject.org/
@@ -80,6 +80,9 @@ cd build
 
 
 %changelog
+* Mon Oct 28 2013 Endi S. Dewata <edewata@redhat.com> 10.0.6-1
+- Updated version number.
+
 * Fri Sep 6 2013 Ade Lee <alee@redhat.com> 10.0.5-1
 - Roll release to next version
 
diff --git a/specs/pki-core.spec b/specs/pki-core.spec
index 96e8d02f5cc2700f7669865141090f09bbd57ed9..b06715f16a4e2cbe219343d82cb8e19c1f1c8c6c 100644
--- a/specs/pki-core.spec
+++ b/specs/pki-core.spec
@@ -4,7 +4,7 @@ distutils.sysconfig import get_python_lib; print(get_python_lib())")}
 distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
 
 Name:             pki-core
-Version:          10.0.5
+Version:          10.0.6
 Release:          1%{?dist}
 Summary:          Certificate System - PKI Core Components
 URL:              http://pki.fedoraproject.org/
@@ -1134,6 +1134,11 @@ fi
 
 
 %changelog
+* Mon Oct 28 2013 Endi S. Dewata <edewata@redhat.com> 10.0.6-1
+- Store authentication info in session.
+- Fixed error handling in DoUnrevoke servlet.
+- Fixed errors during Tomcat shutdown.
+
 * Fri Sep 6 2013 Ade Lee <alee@redhat.com> 10.0.5-1
 - Roll release to next version
 
diff --git a/specs/pki-migrate.spec b/specs/pki-migrate.spec
index 18a4dd02501f33f94d9e9348ad2fe1487062b5b0..2e4472c54be669cfe069b35a77f51120c74f6329 100644
--- a/specs/pki-migrate.spec
+++ b/specs/pki-migrate.spec
@@ -1,5 +1,5 @@
 Name:             pki-migrate
-Version:          10.0.5
+Version:          10.0.6
 Release:          1%{?dist}
 Summary:          Red Hat Certificate System - PKI Migration Scripts
 URL:              http://pki.fedoraproject.org/
@@ -71,6 +71,9 @@ cd build
 
 
 %changelog
+* Mon Oct 28 2013 Endi S. Dewata <edewata@redhat.com> 10.0.6-1
+- Updated version number.
+
 * Fri Sep 6 2013 Ade Lee <alee@redhat.com> 10.0.5-1
 - Roll release to next version
 
diff --git a/specs/pki-ra.spec b/specs/pki-ra.spec
index 961d9460f60faa8683635f008b4a1ed9df5d0f09..1bd6773f189832c1c7b7c85f42e1aebc6fd99a45 100644
--- a/specs/pki-ra.spec
+++ b/specs/pki-ra.spec
@@ -1,5 +1,5 @@
 Name:             pki-ra
-Version:          10.0.5
+Version:          10.0.6
 Release:          1%{?dist}
 Summary:          Certificate System - Registration Authority
 URL:              http://pki.fedoraproject.org/
@@ -198,6 +198,9 @@ fi
 
 
 %changelog
+* Mon Oct 28 2013 Endi S. Dewata <edewata@redhat.com> 10.0.6-1
+- Updated version number.
+
 * Fri Sep 6 2013 Ade Lee <alee@redhat.com> 10.0.5-1
 - Roll release to next version
 
diff --git a/specs/pki-tps.spec b/specs/pki-tps.spec
index 50b7095fb0ffc46e04c621372d7331b64e03c44a..80e1894dc9a5d133c55730f1b0bbe33cc557787b 100644
--- a/specs/pki-tps.spec
+++ b/specs/pki-tps.spec
@@ -1,5 +1,5 @@
 Name:             pki-tps
-Version:          10.0.5
+Version:          10.0.6
 Release:          1%{?dist}
 Summary:          Certificate System - Token Processing System
 URL:              http://pki.fedoraproject.org/
@@ -231,6 +231,9 @@ fi
 
 
 %changelog
+* Mon Oct 28 2013 Endi S. Dewata <edewata@redhat.com> 10.0.6-1
+- Updated version number.
+
 * Fri Sep 6 2013 Ade Lee <alee@redhat.com> 10.0.5-1
 - Roll release to next version
 
-- 
1.8.1.4